Legrand / Raritan Xerus™ JSON-RPC API for Remote Access Devices like KX4-101, KX3G2

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
radm::KvmDevice Interface Reference
Inheritance diagram for radm::KvmDevice:

## Classes
struct | CustomEdidDataChangedEvent
| Event: Custom EDID data changed. More...
struct | CustomEdidLimits
struct | EdidData
| EDID data for a given resolution. More...
struct | TemperatureChangedEvent
| Event: Device temperature has changed. More...
struct | TemperatureReading
| Device temperature reading. More...
struct | UsbProfile
| An uploaded USB profile. More...
struct | UsbProfileAddedEvent
| Event: A USB profile was added. More...
struct | UsbProfileDeletedEvent
| Event: A USB profile was deleted. More...
struct | UsbProfilesChangedEvent
| Event: The list of available USB profiles changed. More...

## Public Types
enum | EdidInterfaceType { DVI , HDMI }
Public Types inherited from radm::Device
enum | State { UNKNOWN , INACTIVE , ACTIVE }

## Public Member Functions
vector< KvmPort > | getKvmPorts ()
| Get KVM ports of this device.
vector< LocalMonitor > | getLocalMonitors ()
| Get monitor(s) locally attached to the device.
LocalPort | getLocalPort ()
| Gets local control port of the device.
TerminalBlock | getTerminalBlock ()
| Get the terminal block of the device.
TemperatureReading | getInternalTemperature ()
| Get the device's internal temperature.
vector< EdidData > | getSupportedResolutionData ()
| Get data of the video resolutions supported by the device.
vector< EdidData > | getCustomEdidData ()
| Get data of the video resolution data uploaded to the device.
int | deleteCustomEdidData (in VideoResolution resolution, in EdidInterfaceType videoInterface)
| Delete previously uploaded custom EDID data.
int | createCustomEdid (in VideoResolution resolution)
| Create custom EDID.
int | validateCustomEdidArgument (in VideoResolution resolution, out double resultingPixelClock)
| Validate custom EDID argument and calculate pixel clock.
CustomEdidLimits | getCustomEdidLimits ()
| Get limits for custom EDID generation.
vector< UsbProfile > | getUsbProfiles ()
| Get USB profiles available on the device.
int | deleteUsbProfile (in int profileId)
| Delete a previously uploaded USB profile.
Public Member Functions inherited from radm::Device
State | getState ()
| Get device state.
Metadata | getMetadata ()
| Get device meta data.
string | getName ()
| Get device name.
int | setName (in string name)
| Set device name.

## Public Attributes
constant int | ERR_EDID_DATA_IN_USE = 10
| EDID data is in use, cannot be deleted.
constant int | ERR_EDID_GENERATION_FAILED = 11
| Failed to generate custom EDID.
Public Attributes inherited from radm::Device
constant int | ERR_INVALID_ARGUMENT = 1
constant int | ERR_NOT_SUPPORTED = 2

## Detailed Description

Definition at line 14 of file KvmDevice.idl.

## Member Enumeration Documentation

## ◆ EdidInterfaceType

enum radm::KvmDevice::EdidInterfaceType

Enumerator
DVI | DVI EDID data.
HDMI | HDMI EDID data.

Definition at line 30 of file KvmDevice.idl.

## Member Function Documentation

## ◆ createCustomEdid()

int radm::KvmDevice::createCustomEdid | ( | in VideoResolution | resolution | ) |

Create custom EDID.

Parameters

  resolution | Resolution for custom EDID

Returns
  0 if success
  1 if no valid EDID can be generated from the provided resolution
  2 if custom EDID data generation is not supported
  11 if there was an internal error while generating the EDID data

## ◆ deleteCustomEdidData()

int radm::KvmDevice::deleteCustomEdidData | ( | in VideoResolution | resolution,
|  | in EdidInterfaceType | videoInterface )

Delete previously uploaded custom EDID data.

Parameters

  resolution | Video resolution to delete
  videoInterface | Interface type to delete resolution for

Returns
  0 on success
  1 if the given resolution/interface combination could not be found
  10 if the given resolution/interface combination currently is in use

## ◆ deleteUsbProfile()

int radm::KvmDevice::deleteUsbProfile | ( | in int | profileId | ) |

Delete a previously uploaded USB profile.

Parameters

  Profile | ID of the profile to be deleted

Returns
  0 on success
  1 if the profile with the given ID could not be found

## ◆ getCustomEdidData()

vector< EdidData > radm::KvmDevice::getCustomEdidData | ( |  | ) |

Get data of the video resolution data uploaded to the device.

Returns
  List of custom EDID data

## ◆ getCustomEdidLimits()

CustomEdidLimits radm::KvmDevice::getCustomEdidLimits | ( |  | ) |

Get limits for custom EDID generation.

Returns
  limits

## ◆ getInternalTemperature()

TemperatureReading radm::KvmDevice::getInternalTemperature | ( |  | ) |

Get the device's internal temperature.

Returns
  Device temperature reading

## ◆ getKvmPorts()

vector< KvmPort > radm::KvmDevice::getKvmPorts | ( |  | ) |

Get KVM ports of this device.

Returns
  List of KVM ports

## ◆ getLocalMonitors()

vector< LocalMonitor > radm::KvmDevice::getLocalMonitors | ( |  | ) |

Get monitor(s) locally attached to the device.

Returns
  List of locally attached monitors

## ◆ getLocalPort()

LocalPort radm::KvmDevice::getLocalPort | ( |  | ) |

Gets local control port of the device.

Returns
  Local port if present on the device

## ◆ getSupportedResolutionData()

vector< EdidData > radm::KvmDevice::getSupportedResolutionData | ( |  | ) |

Get data of the video resolutions supported by the device.

Returns
  List of EDID data built into the device

## ◆ getTerminalBlock()

TerminalBlock radm::KvmDevice::getTerminalBlock | ( |  | ) |

Get the terminal block of the device.

Returns
  Terminal block if present on the device

## ◆ getUsbProfiles()

vector< UsbProfile > radm::KvmDevice::getUsbProfiles | ( |  | ) |

Get USB profiles available on the device.

Returns
  USB profiles, or an empty list in case USB profiles are not supported

## ◆ validateCustomEdidArgument()

int radm::KvmDevice::validateCustomEdidArgument | ( | in VideoResolution | resolution,
|  | out double | resultingPixelClock )

Validate custom EDID argument and calculate pixel clock.

Parameters

  resolution | Resolution for custom EDID
  resultingPixelClock | Pixel clock calculated if valid (output)

Returns
  0 if validation successful
  1 if the provided resolution is not valid for EDID generation
  2 if if custom EDID data generation is not supported

## Member Data Documentation

## ◆ ERR_EDID_DATA_IN_USE

constant int radm::KvmDevice::ERR_EDID_DATA_IN_USE = 10

EDID data is in use, cannot be deleted.

Definition at line 16 of file KvmDevice.idl.

## ◆ ERR_EDID_GENERATION_FAILED

constant int radm::KvmDevice::ERR_EDID_GENERATION_FAILED = 11

Failed to generate custom EDID.

Definition at line 17 of file KvmDevice.idl.

The documentation for this interface was generated from the following file:

- KvmDevice.idl